﻿namespace ExcelEngineIssue
{
    using System;
    using System.Windows.Forms;
    using Infragistics.Documents.Excel;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            UpdateValues();
        }

        public string DetailA28 = string.Empty;
        public string DetailA29 = string.Empty;
        public string DetailA30 = string.Empty;
        public string DetailA31 = string.Empty;

        public string DetailE16 = string.Empty;
        public string DetailE17 = string.Empty;
        public string DetailE18 = string.Empty;

        public string DetailE13 = string.Empty;

        public string FormulaOutput = string.Empty;
        private static Workbook _wb;
        private static Workbook wb {
            get
            {
                if (_wb != null)
                {
                    return _wb;
                }
                else
                {
                    _wb = Workbook.Load(@"../../Estimate2.xlsx");
                    return _wb;
                }
            }
            set
            {
                _wb = value;
            }
        }

     

        private void UpdateValues()
        {
            DetailE13 = wb.Worksheets["Detail"].Rows[12].Cells[4].Value.ToString();

            DetailA28 = wb.Worksheets["Detail"].Rows[27].Cells[0].Value.ToString();
            DetailA29 = wb.Worksheets["Detail"].Rows[28].Cells[0].Value.ToString();
            DetailA30 = wb.Worksheets["Detail"].Rows[29].Cells[0].Value.ToString();
            DetailA31 = wb.Worksheets["Detail"].Rows[30].Cells[0].Value.ToString();

            DetailE16 = wb.Worksheets["Detail"].Rows[15].Cells[4].Value.ToString();
            DetailE17 = wb.Worksheets["Detail"].Rows[16].Cells[4].Value.ToString();
            DetailE18 = wb.Worksheets["Detail"].Rows[17].Cells[4].Value.ToString();

            FormulaOutput = wb.Worksheets["Summary"].Rows[3].Cells[3].Value.ToString();

            detailE13output.Text = DetailE13;

            detailE16output.Text = DetailE16;
            detailE17output.Text = DetailE17;
            detailE18output.Text = DetailE18;

            detailA31output.Text = DetailA31;
            detailA30output.Text = DetailA30;
            detailA29output.Text = DetailA29;
            detailA28output.Text = DetailA28;

            formulaOutputTb.Text = FormulaOutput;

        }

        private void button1_Click(object sender, EventArgs e)
        {
            UpdateValues();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            // Set A31 to true
            wb.Worksheets["Detail"].Rows[30].Cells[0].Value = "TRUE";
            // Set E1 to 10
            wb.Worksheets["Detail"].Rows[0].Cells[4].Value = 10;
            // Set E13 to 2
            wb.Worksheets["Detail"].Rows[12].Cells[4].Value = 2;
            // Set E14 to 2
            wb.Worksheets["Detail"].Rows[13].Cells[4].Value = 2;
            // Set E18 to 10
            wb.Worksheets["Detail"].Rows[17].Cells[4].Value = 10;

            UpdateValues();
        }
    }
}
